![ICON Logo](./doc/contrib/ICON_logo_black.jpg){: width="250px" height="100px" align="left"}

---

**ICON** - is a modeling framework for weather, climate, and environmental prediction. It solves the full three-dimensional non-hydrostatic and compressible Navier-Stokes equations on an icosahedral grid and allows seamless predictions from local to global scales.

[TOC]


# Partnership

The ICON partnership coordinates research activities developing, maintaining, and supporting the ICON modeling framework. 

ICON partner institutions are:
- [DWD](https://www.dwd.de/EN/Home/home_node.html)
- [MPI-M](https://www.mpimet.mpg.de/en/home/)
- [DKRZ](https://www.dkrz.de/en/dkrz-partner-for-climate-research?set_language=en)
- [KIT](https://www.kit.edu/english/index.php)
- [C2SM](https://c2sm.ethz.ch/): [ETH](https://ethz.ch/en.html) and [MeteoSwiss](https://www.meteoswiss.admin.ch/)


More information about ICON is available in the [project's public web page](http://icon-model.org).


# License

ICON is available under a BSD 3-clause license. See [LICENSES/](./LICENSES) for license information and [AUTHORS.TXT](./AUTHORS.TXT) for a list of authors.


# Versioning

The name of the release version is documented in the [VERSION](./VERSION) file in the root folder.

ICON versions are named using the scheme `icon-yyyy.mm` where `yyyy` is the year and `mm` is the month of the release. The very first open source release of ICON is version icon-2024.01, release date January 2024. If patches are needed for a particular release, they will be icon-yyyy.mm-n with n starting at 1. Note: The patch-level 0 is the basic release. The 0 is not explicitly written to the version string.


# Quick Start

The [Quick Start](./doc/Quick_Start.md) provides technical details on how to build the model, as well as the description of basic steps required to run it. 
